{
  Promathika - ein multifunktionales Programm zum Zeichnen von Funktionen

    Copyright (C) 2009  Arthur Schmidt, Alexander Staidl

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License Version 3 as published by
    the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
}


function tAnalyse.WasNun_Abl(funktion:string):integer; //-1==;0=+,-;1=*,/;2=^;3=sin,cos,...;4=();5=nichts;6=ERROR
var WN, n, KlAuf, laenge:integer;
    s,sdavor:string;
begin
  WN:=5; n:=0; KlAuf:=0;
  sdavor:='';
  laenge:=length(funktion);
  repeat
    inc(n);
    s:=funktion[n];
    if s='(' then
    begin
      KlAuf:=KlAuf+1;
      if WN>4 then WN:=4;
      if (WN>3)and(IstBuchstabe(sdavor)=true)and(KlAuf=1) then WN:=3;      //denn dann handelt es sich um eine Funktion, bsp sin(x)
    end;
    if s=')' then KlAuf:=KlAuf-1;
    if (s='^')and(KlAuf=0)and(WN>2) then WN:=2;
    if ((s='*')or(s='/'))and(KlAuf=0)and(WN>1)then WN:=1;
    if ((s='+')or(s='-'))and(KlAuf=0)and(WN>0) then WN:=0;
    if (s='=')and(KlAuf=0) then WN:=-1;
    sdavor:=s;
  until (n>=laenge)or(WN=0);
  If KlAuf=0 then WasNun_Abl:=WN else WasNun_Abl:=6;
end; //WasNun_Abl


function tAnalyse.IstBuchstabe(z:String):Boolean;
begin
  IstBuchstabe:=true;
  If z='' then IstBuchstabe:=false else
  begin
    If length(z)>1 then IstBuchstabe:=false;
    If ord(z[1])<65 then IstBuchstabe:=false;
    If (ord(z[1])>90)and(ord(z[1])<97) then IstBuchstabe:=false;
    If ord(z[1])>122 then IstBuchstabe:=false;
  end;
end;


function tAnalyse.ZeichenErlaubt(z:string):boolean;
var n:integer;
begin
  ZeichenErlaubt:=true;
  for n:=1 to length(z) do
  begin
    If (ord(z[n])<40)and(z[n]<>' ') then ZeichenErlaubt:=false;
    If (ord(z[n])>57)and(ord(z[n])<65) then ZeichenErlaubt:=false;
    If (ord(z[n])=95)or(ord(z[n])=96)or(ord(z[n])=124) then ZeichenErlaubt:=false;
    If ord(z[n])>125 then ZeichenErlaubt:=false;
  end;
end;


function tAnalyse.IstZahl(z:string):boolean;
var Zb:boolean;
    n:integer;
begin
  Zb:=false; n:=0;
  if z<>'' then
  repeat
    inc(n);
    if (z[n]='0')or(z[n]='1')or(z[n]='2')or(z[n]='3')or(z[n]='4')or(z[n]='5')or(z[n]='6')or(z[n]='7')
     or(z[n]='8')or(z[n]='9')or(z[n]=',')or(midstr(z,n,1)='') then Zb:=true else Zb:=false;
  until (n=length(z))or(Zb=false);
  IstZahl:=Zb;
end; //IstZahl


function tAnalyse.IstNatuerlicheZahl(Eingabe:string):boolean;
var n:dword;
begin
  If Eingabe <>'' then
  begin
    RESULT:=true;
    n:=0;
    repeat
      inc(n);
      RESULT := (ord(Eingabe[n])>=48)and(ord(Eingabe[n])<=57)
    until (n=length(Eingabe))or(RESULT=false);
  end else RESULT:=false;
end;


function tAnalyse.IstVerknuepfung(s:string):boolean;
begin
  If (s='+')or(s='-')or(s='*')or(s='/')or(s='^') then IstVerknuepfung:=true else IstVerknuepfung:=false;
end;


function tAnalyse.TermKorrPruef(Term:string):string; //Fehler-Nr. in UKonsole gelistet
var n, n2, laenge, KlAuf, KlAuf2:integer;
    s, s2, sdavor:string;
begin
  n:=0; KlAuf:=0;
  laenge:=length(Term);
  sdavor:='';
  repeat
    inc(n);
    s:=Term[n];
    If ((ord(s[1])<40)and(ord(s[1])<>32)and(ord(s[1])<>0))or(ord(s[1])>125)or((ord(s[1])>57)and(ord(s[1])<65))or(s='|')or(ord(s[1])=96)
     then Err:=9;    //Error bei unerlaubten Zeichen. Muss gegebenenfalls noch um Zeichen erweitert werden.
    if s=' ' then  // Leerzeichen entfernen
    begin
      delete(Term,n,1);
      dec(n); dec(laenge);
      if n=1 then sdavor:='' else sdavor:=Term[n-1];
    end;
    if s='.' then
    begin
      delete(Term,n,1);
      insert(',',Term,n);
    end;
    if (s='[')or(s='{') then
    begin
      delete(Term,n,1);
      insert('(',Term,n);
    end;
    if (s=']')or(s='}') then
    begin
      delete(Term,n,1);
      insert(')',Term,n);
    end;
    if (s<>'E')and(s<>lowercase(s)) then
    begin
      delete(Term,n,1);
      insert(lowercase(s),Term,n);
    end;
    If IstVerknuepfung(s)=true then
    begin
      If IstVerknuepfung(sdavor)=true then if n=laenge then Err:=4 else
      if (s='-') and (sdavor='^') then                                          // Umwandlung: x^-2 ==> x^(-2)
      begin
        insert('(',Term,n);
        inc(laenge);
        inc(n);                                                             // Setzt wieder beim - an, um z.B. Exponent von 2^-sin{x} ebenfalls zu korrigieren.
        inc(KlAuf);                                                         // Da n innerhalb der neu geschaffenen Klammer ansetzt, musst der Klammerzähler hochgesetzt werden.
        sdavor:=Term[n-1];
        n2:=n+1;                                                            // Damit kommende While-Schleife nicht sofort abbricht.
        KlAuf2:=0;                                                          // Damit sich z.B. bei 2^-sin(x+3) nicht die Klammer hinter vor dem + schon schließt muss gezählt werden, ob sich das + in einer Klammer befindet.
        while ((IstVerknuepfung(Term[n2])=false)or(KlAuf2>0))and(n2<laenge) do
        begin
          If Term[n2]='(' then inc(KlAuf2) else if Term[n2]=')' then dec(KlAuf2);
          inc(n2);
        end;
        If n2=laenge then Term:=Term + ')' else insert(')',Term,n2);
        inc(laenge);
      end else Err:=4;
      If ((sdavor='(')or(sdavor=''))and(s<>'-') then if s='+' then
      begin
        delete(Term,n,1);
        dec(n); dec(laenge);
      end else Err:=4;
    end;
    If ((IstZahl(sdavor)=true)or(sdavor=')'))and((s='(')or(IstBuchstabe(s)=true)or(s='_')) then
    begin
      insert('*',Term,n);
      inc(laenge); inc(n);
    end;
    if (s='e') and (sdavor<>'_') and (not IstBuchstabe(sdavor)) then if n<laenge then           // Komplizierte If, damit z.B. nicht exp(x)--> _exp(x) oder sec(x) --> s_ec(x)
    begin
      if not IstBuchstabe(Term[n+1]) then
      begin
        insert('_',Term,n);
        inc(laenge); inc(n);
        sdavor:='_';
      end;
    end else
    begin
      insert('_',Term,n);
      inc(laenge); inc(n);
      sdavor:='_';
    end; // if s='e' else
    If s='(' then
    begin
      inc(KlAuf);
      if IstBuchstabe(sdavor)=true then
      begin
        n2:=n; s2:='';
        repeat
        dec(n2);
          If (IstBuchstabe(Term[n2])=true)and(n2>1) then s2:=Term[n2] + s2 else
           begin
             if (n2=1)and(Term[1]<>'(')and(Term[1]<>'-') then s2:=Term[1] + s2;
             if (s2<>'ln')and(s2<>'exp')and(s2<>'sin')and(s2<>'cos')and(s2<>'tan')and(s2<>'cot')and(s2<>'sec')
              and(s2<>'csc')and(s2<>'abs')and(s2<>'sign')and(s2<>'sinh')and(s2<>'cosh')and(s2<>'tanh')
              and(s2<>'coth')and(s2<>'sech')and(s2<>'csch')and(s2<>'sqrt')and(s2<>'arcsin')and(s2<>'arccos')and(s2<>'arctan')
              and(s2<>'arccot')and(s2<>'arcsec')and(s2<>'arccsc')and(s2<>'arsinh')and(s2<>'arcosh')
              and(s2<>'artanh')and(s2<>'arcoth')and(s2<>'arsech')and(s2<>'arcsch')
              then Err:=3;
             n2:=1;  //Abbruchbedingung
           end;
        until (n2=1)or(Err=3);
      end;
    end;
    If s=')' then
    begin
      dec(KlAuf);
      if (KlAuf<0)or(sdavor='(') then Err:=5;
      if IstVerknuepfung(sdavor) then Err:=4;
    end;
    sdavor:=s;
  until (n>=laenge)or(Err<>0);

  If (laenge=0) then Err:=6;
  If (KlAuf<>0)and(Err=0) then Err:=5;
  If laenge<>0 then if IstVerknuepfung(Term[laenge])=true then Err:=4;
  TermKorrPruef:=Term;
end; // TermKorrPruef


procedure tAnalyse.ZeichenPruef_FWert(Term:string); //Prüft, ob Term für FunkWert geeignet.
var n, laenge:integer;                              //Im Unterschied zu TermKorrPruef ist nur x als Variable zugelassen.
    s, s2:string;
begin
  n:=0;
  laenge:=length(Term);
  repeat
    inc(n);
    s:=Term[n];

    if (IstBuchstabe(s)=true)and(s<>'x') then
    begin
      s2:='';
      repeat
        s:=term[n];
        If IstBuchstabe(s)=true then s2:=s2+s;
        inc(n);
      until (n>laenge)or(IstBuchstabe(s)=false);
      dec(n);
      if (s2<>'ln')and(s2<>'exp')and(s2<>'sin')and(s2<>'cos')and(s2<>'tan')and(s2<>'cot')and(s2<>'sec')
       and(s2<>'csc')and(s2<>'abs')and(s2<>'sign')and(s2<>'sinh')and(s2<>'cosh')and(s2<>'tanh')
       and(s2<>'coth')and(s2<>'sech')and(s2<>'csch')and(s2<>'sqrt')and(s2<>'arcsin')and(s2<>'arccos')and(s2<>'arctan')
       and(s2<>'arccot')and(s2<>'arcsec')and(s2<>'arccsc')and(s2<>'arsinh')and(s2<>'arcosh')
       and(s2<>'artanh')and(s2<>'arcoth')and(s2<>'arsech')and(s2<>'arcsch')and(s2<>'pi')and(s2<>'e')
       then Err:=3;
       
    end;
  until (n>=laenge)or(Err=3);
end;


procedure tAnalyse.TTTermFreigabe(var Pointer:PTermTyp);
begin
  CASE Pointer^.Opera OF
    004: begin TTTermFreigabe(Pointer^.Arg1); TTTermFreigabe(Pointer^.Arg2); end;   //004=Addition
    005: begin TTTermFreigabe(Pointer^.Arg1); TTTermFreigabe(Pointer^.Arg2); end;   //005=Multiplikation
    006: begin TTTermFreigabe(Pointer^.Arg1); TTTermFreigabe(Pointer^.Arg2); end;   //006=Potenz
    101: TTTermFreigabe(Pointer^.Arg1);                                             //101=ln
  //102: Entfällt, da exp(x) durch _e^x ersetzt wurde.
    103: TTTermFreigabe(Pointer^.Arg1);                                             //103=sin
    104: TTTermFreigabe(Pointer^.Arg1);                                             //104=cos
    105: TTTermFreigabe(Pointer^.Arg1);                                             //105=tan
    106: TTTermFreigabe(Pointer^.Arg1);                                             //106=cot
    107: TTTermFreigabe(Pointer^.Arg1);                                             //107=sec
    108: TTTermFreigabe(Pointer^.Arg1);                                             //108=csc
    109: TTTermFreigabe(Pointer^.Arg1);                                             //109=abs
    110: TTTermFreigabe(Pointer^.Arg1);                                             //110=sign
    111: TTTermFreigabe(Pointer^.Arg1);                                             //111=sinh
    112: TTTermFreigabe(Pointer^.Arg1);                                             //112=cosh
    113: TTTermFreigabe(Pointer^.Arg1);                                             //113=tanh
    114: TTTermFreigabe(Pointer^.Arg1);                                             //114=coth
    115: TTTermFreigabe(Pointer^.Arg1);                                             //115=sech
    116: TTTermFreigabe(Pointer^.Arg1);                                             //116=csch
    117: TTTermFreigabe(Pointer^.Arg1);                                             //117=arcsin
    118: TTTermFreigabe(Pointer^.Arg1);                                             //118=arccos
    119: TTTermFreigabe(Pointer^.Arg1);                                             //119=arctan
    120: TTTermFreigabe(Pointer^.Arg1);                                             //120=arccot
    121: TTTermFreigabe(Pointer^.Arg1);                                             //121=arcsec
    122: TTTermFreigabe(Pointer^.Arg1);                                             //122=arccsc
    123: TTTermFreigabe(Pointer^.Arg1);                                             //123=arsinh
    124: TTTermFreigabe(Pointer^.Arg1);                                             //124=arcosh
    125: TTTermFreigabe(Pointer^.Arg1);                                             //125=artanh
    126: TTTermFreigabe(Pointer^.Arg1);                                             //126=arcoth
    127: TTTermFreigabe(Pointer^.Arg1);                                             //127=arsech
    128: TTTermFreigabe(Pointer^.Arg1);                                             //128=arcsch
  end;
  If assigned(Pointer) then Dispose(Pointer);
  Pointer := nil;
end; // TTTermFreigabe


function tAnalyse.TTKopieVon(Term:PTermTyp):PTermTyp;
var ZwSp:PTermTyp;
begin
  new(ZwSp);
  ZwSp^:=Term^;
  If (Term^.Opera>=4)and(Term^.Opera<=6) then
  begin
    ZwSp^.Arg1:=TTKopieVon(Term^.Arg1);
    ZwSp^.Arg2:=TTKopieVon(Term^.Arg2);
  end else if (Term^.Opera>=101)and(Term^.Opera<=128) then ZwSp^.Arg1:=TTKopieVon(Term^.Arg1) else if Term^.Opera=001 then
  begin
    ZwSp^.ZahlGRaZ:=GRaZcopy(Term^.ZahlGRaZ);                                       // da sonst nur der Array-Pointer kopiert wird.
  end;
  TTKopieVon:=ZwSp;
end; // TTKopieVon
